---
- stat: path="{{ apnscp_root }}/storage/opcenter/passwd"
  register: passchk
- copy:
    dest: "{{ apnscp_root }}/storage/opcenter/passwd"
    content: "{{ apnscp_admin_user }}:{{ apnscp_admin_password | password_hash('sha512') }}"
  when: not passchk.stat.exists or passchk.stat.size == 0
- meta: flush_handlers
- name: Start apnscp
  systemd: state=started name=apnscp enabled=yes
- set_fact: __apnscp_admin_password={{ apnscp_admin_password }}
  when: not passchk.stat.exists or passchk.stat.size == 0
- block:
  - wait_for: path="{{ apnscp_root }}/storage/run/apnscp.sock" state=present
  - name: "Setting admin password"
    command: "{{ apnscp_root }}/bin/cmd auth_change_password {{ __apnscp_admin_password|quote }} {{ apnscp_admin_user|quote }}"
  - debug: msg="Admin password set to {{ __apnscp_admin_password }}" verbosity=1
  when: __apnscp_admin_password is defined
- stat: path="{{ opcenter_path }}"
  register: s
- name: Restart apnscp housekeeper
  systemd: state=restarted name=apnscp
  when: not s.stat.exists
  # @TODO systemd can be finnicky if apnscpd restarts without formally restarting entire
  # service thus killing it on startup... Add an extra check that should succeed
- shell:
    kill -0 "$(cat {{ apnscpd_pid }})" || ( systemctl restart apnscp && false )
  failed_when: false
  register: o
  until: o.rc == 0
  retries: 3
  delay: 7
  changed_when: false
- wait_for: path="{{ opcenter_path }}" state=present
  retries: 5
  delay: 10
- command: "{{ apnscp_root }}/bin/cmd admin_get_email"
  register: c
  changed_when: false
- name: "Setting admin email to {{ apnscp_admin_email | default('----NOT DEFINED----') }}"
  command: "{{ apnscp_root }}/bin/cmd admin_set_email {{ apnscp_admin_email|quote }}"
  when: not (apnscp_admin_email is none or apnscp_admin_email|regex_search('^\s*$')) and c.stdout != apnscp_admin_email
# @TODO bust out to end? Doesn't make sense in here...
- name: Run initial database migration
  shell: ./artisan migrate --dbonly --force ; ./artisan config:cache
  args:
    chdir: "{{ apnscp_root}}"
  register: s
  changed_when: '"Nothing to migrate" not in s.stdout'
  when: >-
    not passchk.stat.exists or
    passchk.stat.size == 0 or
    apply_pending_migrations == "db" or
    apply_pending_migrations == True
